<?php
include 'xmlrpc.inc';
include 'xmlrpcs.inc';

function math_graphic ($params) {

    $padding = 20;
    $delim = 5;

    // ᨬ ࠬ.
    $strt = $params->getParam(0)->scalarval();
    $stop = $params->getParam(1)->scalarval();
    $xdim = $params->getParam(2)->scalarval();
    $ydim = $params->getParam(3)->scalarval();
    $func = $params->getParam(4)->scalarval();
    $name = $params->getParam(5)->scalarval();

    $step = (max($strt,$stop) - min($strt,$stop)) / ($xdim-2*$padding);
    $step = max($step, 1.0E-05);

    //   ૮ ॣ ࠦ 塞 ⤥ ᫮ 'x'
    //  ६ '$x'
    $myfunc = 'return ' . preg_replace( "/\\bx\\b/", '$x', $func) . ';';

    $values = array();

    $fmin =  1.0E+09;
    $fmax = -1.0E+09;

    for($cx=$padding, $x = min($strt,$stop); $cx <= $xdim-$padding; $x += $step, $cx++) {
      $f = eval($myfunc);
      $values[$cx] = $f;
      $fmin = min($f,$fmin);
      $fmax = max($f,$fmax);
    }

    $coef = ($ydim - 2*$padding) / ($fmax - $fmin);

    $img = imagecreate ($xdim, $ydim);

    //  뤥 梥 - 梥 䮭 ()
    $bkcolor = imagecolorallocate($img, 255, 255, 255);

    // 梥 ⥪ - ᭮
    $textcolor = imagecolorallocate($img, 200, 150, 100);

    imagestring($img, 3, $padding+4,  0, "F(x)=" . $func, $textcolor);
    imagestring($img, 3, $padding+4, 12, "Fmin=" . $fmin, $textcolor);
    imagestring($img, 3, $padding+4, 24, "Fmax=" . $fmax, $textcolor);
    imagestring($img, 3, $padding+4, 36, "Xmin=" . $strt, $textcolor);
    imagestring($img, 3, $padding+4, 48, "Xmax=" . $stop, $textcolor);

    // 梥 䨪 - ᨭ
    $color = imagecolorallocate($img, 50, 10, 150);

    for($cx=$padding; $cx < $xdim-$padding; $cx++) {
      $cy1 = $ydim - $padding - ($values[$cx+0] - $fmin) * $coef;
      $cy2 = $ydim - $padding - ($values[$cx+1] - $fmin) * $coef;
      imageline($img, $cx, $cy1, $cx+1, $cy2, $color);
    }

    // 梥 ᥩ  ⬥⮪ - 
    $color = imagecolorallocate($img, 0, 0, 0);

    //    㭪
    imageline($img, $padding, $padding, $padding, $ydim-$padding, $color);
    imageline($img, $padding, $ydim-$padding, $xdim-$padding, $ydim-$padding, $color);

    // ⬥⪨  ⨪쭮 
    for($cy=$padding; $cy <= $ydim-$padding; $cy+=20) {
      imageline($img, $padding, $cy, $padding-$delim, $cy, $color);
    }

    // ⬥⪨  ਧ⠫쭮 
    for($cx=$padding; $cx <= $xdim-$padding; $cx+=20) {
      imageline($img, $cx, $ydim-$padding, $cx, $ydim-$padding+$delim, $color);
    }

    // ⮢   䠩
//    imagepng($img, 'test.png');

    // php 㬥  㭪   䠩  אַ  .    㣮   ,
    //     ६  ⮬ ஢  ⥪.
    // ⮬ 砥 ਧ 뢮  , 뢮 㭮,  ᮤন   ६,
    // ⪫砥 ਧ  ᮬ   .
    ob_start();
    imagepng($img);
    $data = ob_get_contents();
    ob_end_clean();
    //$data = base64_encode($data);


    // 뢠 १  XML, 뢠  ⨯ -  ᯮᮡ ᨨ  ⥪.
    $struct = array('fmin' => new xmlrpcval($fmin, 'double'),
                    'fmax' => new xmlrpcval($fmax, 'double'),
                    'func' => new xmlrpcval($func, 'string'),
                    'name' => new xmlrpcval($name, 'string'),
                    'data' => new xmlrpcval($data, 'base64'));

    // 뫠
    return new xmlrpcresp(new xmlrpcval($struct, 'struct'));
}

// ⮭ 䨪 f(x,y)
function math_plot ($params) {

    // Parse our parameters.
    $xstrt = $params->getParam(0)->scalarval();
    $xstop = $params->getParam(1)->scalarval();
    $ystrt = $params->getParam(2)->scalarval();
    $ystop = $params->getParam(3)->scalarval();

    $xdim = $params->getParam(4)->scalarval();
    $ydim = $params->getParam(5)->scalarval();

    $func = $params->getParam(6)->scalarval();

    $xname = $params->getParam(7)->scalarval();
    $yname = $params->getParam(8)->scalarval();

    $xstep = (max($xstrt,$xstop) - min($xstrt,$xstop)) / $xdim;
    $xstep = max($xstep, 1.0E-05);

    $ystep = (max($ystrt,$ystop) - min($ystrt,$ystop)) / $ydim;
    $ystep = max($ystep, 1.0E-05);


    //   ૮ ॣ ࠦ 塞
    //  ⤥ ᫮ 'y'  ६ '$y'
    $myfunc = preg_replace( "/\\by\\b/", '$y', $func);
    //  ⤥ ᫮ 'x'  ६ '$x'
    $myfunc = preg_replace( "/\\bx\\b/", '$x', $myfunc);
//    $myfunc = 'return ' . $myfunc . ';';

    // ।塞 - 㭪樨  襩 
    $fmin =  1.0E+09;
    $fmax = -1.0E+09;

/*
    for($cx=0, $x = min($xstrt,$xstop); $cx < $xdim; $x += $xstep, $cx++) {
      for($cy=0, $y = min($ystrt,$ystop); $cy < $ydim; $y += $ystep, $cy++) {
        $f = eval($myfunc);
        $fmin = min($f,$fmin);
        $fmax = max($f,$fmax);
      }
    }
*/
  eval('
    for($cx=0, $x = min($xstrt,$xstop); $cx < $xdim; $x += $xstep, $cx++) {
      for($cy=0, $y = min($ystrt,$ystop); $cy < $ydim; $y += $ystep, $cy++) {
        $f = (' . $myfunc . ');
        $fmin = min($f,$fmin);
        $fmax = max($f,$fmax);
      }
    }');


    $coef = 255.0 / ($fmax - $fmin);

    $img = imagecreate ($xdim, $ydim);

    // ந  梥⮢
    $colors = array();
    for($i=0; $i<256; $i++) {
      $colors[$i] = imagecolorallocate($img, $i, $i, $i);
    }

    // ᥫ쭮 㥬
/*
    for($cx=0, $x = min($xstrt,$xstop); $cx < $xdim; $x += $xstep, $cx++) {
      for($cy=0, $y = min($ystrt,$ystop); $cy < $ydim; $y += $ystep, $cy++) {
        $f = eval($myfunc);
        $color = round(($f - $fmin) * $coef);
        imagesetpixel ($img, $cx, $cy, $colors[$color]);
      }
    }
*/
  eval('
    for($cx=0, $x = min($xstrt,$xstop); $cx < $xdim; $x += $xstep, $cx++) {
      for($cy=0, $y = min($ystrt,$ystop); $cy < $ydim; $y += $ystep, $cy++) {
        $f = (' . $myfunc . ');
        $color = round(($f - $fmin) * $coef);
        imagesetpixel ($img, $cx, $cy, $colors[$color]);
      }
    }');

//    imagepng($img, 'test.png');

    // 뢠 㭮  ६ १ 
    ob_start();
    imagepng($img);
    $data = ob_get_contents();
    ob_end_clean();
    //$data = base64_encode($data);


    // Build our response.
    $struct = array('fmin'  => new xmlrpcval($fmin, 'double'),
                    'fmax'  => new xmlrpcval($fmax, 'double'),
                    'func'  => new xmlrpcval($func, 'string'),
                    'xname' => new xmlrpcval($xname, 'string'),
                    'yname' => new xmlrpcval($yname, 'string'),
                    'data'  => new xmlrpcval($data, 'base64'));

    return new xmlrpcresp(new xmlrpcval($struct, 'struct'));
}


// ⥣஢
function math_integral ($params) {

    $xdim = 800;

    // Parse our parameters.
    $strt = $params->getParam(0)->scalarval();
    $stop = $params->getParam(1)->scalarval();

    $step = (max($strt,$stop) - min($strt,$stop)) / $xdim;
    $step = max($step, 1.0E-05);

    $func = $params->getParam(2)->scalarval();
    $name = $params->getParam(3)->scalarval();

    $myfunc = 'return ' . preg_replace( "/\\bx\\b/", '$x', $func) . ';';

    $fmin =  1.0E+09;
    $fmax = -1.0E+09;

    // 㬬㥬  ᮭ (饥 ᫮ ࢠ ⭮, 㧫 ⭮):
    // ࠩ 㧫  ᮬ 1/3
    //  㧫  ᮬ 4/3
    //  㧫  ᮬ 2/3
    $data = 0;
    $x = min($strt,$stop);
    $f = eval($myfunc);
    $data += $f * $step / 3.0;
    $fmin = min($f,$fmin);
    $fmax = max($f,$fmax);

    for($x=$x+$step, $cx=1; $cx < $xdim; $cx++) {
      $f = eval($myfunc);

      if(($cx & 1) == 1)
        $data += $f * $step * 4.0 / 3.0;
      else
        $data += $f * $step * 2.0 / 3.0;

      $fmin = min($f,$fmin);
      $fmax = max($f,$fmax);
      $x += $step;
    }

    $f = eval($myfunc);
    $data += $f * $step / 3.0;
    $fmin = min($f,$fmin);
    $fmax = max($f,$fmax);


    // Build our response.
    $struct = array('fmin' => new xmlrpcval($fmin, 'double'),
                    'fmax' => new xmlrpcval($fmax, 'double'),
                    'func' => new xmlrpcval($func, 'string'),
                    'name' => new xmlrpcval($name, 'string'),
                    'data' => new xmlrpcval($data, 'double'));

    return new xmlrpcresp(new xmlrpcval($struct, 'struct'));
}

// ⮤  襭 ࠢ
function math_equation ($params) {

    $xdim = 4000;

    // Parse our parameters.
    $strt = $params->getParam(0)->scalarval();
    $stop = $params->getParam(1)->scalarval();

    $step = (max($strt,$stop) - min($strt,$stop)) / $xdim;
    $step = max($step, 1.0E-05);

    $func = $params->getParam(2)->scalarval();
    $name = $params->getParam(3)->scalarval();

    $myfunc = 'return ' . preg_replace( "/\\bx\\b/", '$x', $func) . ';';

    $values = array();
    for($x=min($strt,$stop), $cx=0; $cx < $xdim; $cx++) {
      $f = eval($myfunc);
      $values[$cx] = $f;
      $x += $step;
    }

    $res = array();
    $count=0;
    for($x=min($strt,$stop), $cx=1; $cx < $xdim; $cx++) {
      if($values[$cx-1] * $values[$cx] < 0) {
        $res['x' . $count] = new xmlrpcval($x + $step/2, 'double');
        $count++;
      }
      $x += $step;
    }
    $res['count'] = new xmlrpcval($count, 'int');

    // Build our response.
    return new xmlrpcresp(new xmlrpcval($res, 'struct'));
}

// 뢠 ᨣ (⨯  - ࠬ஢) ⮤, 㬥㥬    ⮤.
$math_graphic_sig = array(array('struct', 'double', 'double', 'int', 'int', 'string', 'string'));
$math_graphic_doc = 'Make graphic';

$math_plot_sig = array(array('struct', 'double', 'double', 'double', 'double', 'int', 'int', 'string', 'string', 'string'));
$math_plot_doc = 'Make plot graphic';

$math_integral_sig = array(array('struct', 'double', 'double', 'string', 'string'));
$math_integral_doc = 'Compute Integral';

$math_equation_sig = array(array('struct', 'double', 'double', 'string', 'string'));
$math_equation_doc = 'Solve Equation';

// create server instance with 4 methods
new xmlrpc_server(array(

'sample.math_graphic'  => array('function' => 'math_graphic',
                               'signature' => $math_graphic_sig,
                               'docstring' => $math_graphic_doc),

'sample.math_plot'     => array('function' => 'math_plot',
                               'signature' => $math_plot_sig,
                               'docstring' => $math_plot_doc),

'sample.math_integral' => array('function' => 'math_integral',
                               'signature' => $math_integral_sig,
                               'docstring' => $math_integral_doc),

'sample.math_equation' => array('function' => 'math_equation',
                               'signature' => $math_equation_sig,
                               'docstring' => $math_equation_doc)

                 ));
?>